/* cmdline.h */

/* File autogenerated by gengetopt version 2.16  */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "phc"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "0.1.6"
#endif

struct gengetopt_args_info
{
  int generate_ir_flag;	/* Compile the PHP script to phc's internal representation (ALPHA) (default=off).  */
  int dump_tokens_flag;	/* Perform lexical analysis only (spits out a token list). Probably only useful for debugging phc itself (default=off).  */
  int dump_php_flag;	/* Dump PHP code back immediately after parsing to standard output (pretty printing) (default=off).  */
  int dump_ast_dot_flag;	/* Dump the AST from the source in dot format (default=off).  */
  int dump_ast_xml_flag;	/* Dump the AST from the source in XML format (default=off).  */
  int no_line_numbers_flag;	/* Don't include line numbers when dumping AST/XML (default=off).  */
  int compile_time_includes_flag;	/* When possible, replace include() statements with the parsed contents of the specified file (default=off).  */
  char * tab_arg;	/* String to use for tabs while unparsing (default='\t').  */
  char * tab_orig;	/* String to use for tabs while unparsing original value given at command line.  */
  int no_validation_flag;	/* Toggle XML validation (default=on).  */
  int test_linear_flag;	/* Test that the tree generated by the parser does not have any shared nodes (default=off).  */
  int test_cloning_flag;	/* Test that the a tree and its duplicate have no common nodes, and generate the same unparsed php (default=off).  */
  int test_pre_vs_post_count_flag;	/* Test that there are as many post_node calls as pre_node calls in an unmodified tree (default=off).  */
  int test_source_vs_semantic_values_flag;	/* Print out a list of internal values with their associated source code (default=off).  */
  int test_xml_roundtrip_flag;	/* Verify whether PHP -> AST = PHP -> XML -> AST (default=off).  */
  
  int help_given ;	/* Whether help was given.  */
  int full_help_given ;	/* Whether full-help was given.  */
  int version_given ;	/* Whether version was given.  */
  int generate_ir_given ;	/* Whether generate-ir was given.  */
  int dump_tokens_given ;	/* Whether dump-tokens was given.  */
  int dump_php_given ;	/* Whether dump-php was given.  */
  int dump_ast_dot_given ;	/* Whether dump-ast-dot was given.  */
  int dump_ast_xml_given ;	/* Whether dump-ast-xml was given.  */
  int no_line_numbers_given ;	/* Whether no-line-numbers was given.  */
  int compile_time_includes_given ;	/* Whether compile-time-includes was given.  */
  int tab_given ;	/* Whether tab was given.  */
  int no_validation_given ;	/* Whether no-validation was given.  */
  int test_linear_given ;	/* Whether test-linear was given.  */
  int test_cloning_given ;	/* Whether test-cloning was given.  */
  int test_pre_vs_post_count_given ;	/* Whether test-pre-vs-post-count was given.  */
  int test_source_vs_semantic_values_given ;	/* Whether test-source-vs-semantic-values was given.  */
  int test_xml_roundtrip_given ;	/* Whether test-xml-roundtrip was given.  */

  char **inputs ; /* unamed options */
  unsigned inputs_num ; /* unamed options number */
} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_full_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
