/*
 * phc -- the open source PHP compiler
 * See license/README.license for licensing information
 * 
 * Error handling 
 */

#ifndef PHC_ERROR
#define PHC_ERROR

#include <stdarg.h>

void error(int code, int line = 0, ...);
void warning(int code, int line = 0, ...);
void internal_error(int code, ...);

// Errors and warnings use the same codes and messages.

// Messages for these errors are defined in error.cpp
#define ERR_BISON 								1
#define ERR_EXPECT_VAR 							2
#define ERR_FOREACH_KEY_REF					3
#define ERR_ABSTRACT_VARS						4
#define ERR_FINAL_VARS							5
#define ERR_XML_PARSE							6
#define ERR_INCLUDE_CLASS_EXISTS				7 
#define ERR_INCLUDE_METHOD_EXISTS			8
#define ERR_INCLUDE_BAD_PARSE					9
#define ERR_INCLUDE_NO_FILE				  10
#define ERR_INCLUDE_RETURN 				  11
#define ERR_INTERNAL							 255

#define INTERNAL_ERR_LOOPING_TRANSFORM		0


#endif
