/*
 * phc -- the open source PHP compiler
 * See license/README.license for licensing information
 *
 * Generic parser context (specialised in PHPParserContext and IRParserContext)
 */

#ifndef PHC_PARSER_CONTEXT
#define PHC_PARSER_CONTEXT

#include <Lexer.h>

class Parser_context : virtual public Object 
{
private:
	Lexer* lexer;

public:
	Parser_context(Lexer* l) : lexer(l) {}
	virtual ~Parser_context() {}

public:
	int yylex(YYSTYPE* lvalp)
	{
		int result = lexer->yylex();
		*lvalp = lexer->get_yylval();
		return result;
	}

public:
	virtual void yyerror(const char* s) = 0;
};


#endif
