/* 
 * phc -- the open source PHP compiler 
 * See license/README.license for licensing information
 *
 * Remove concatenations to empty strings (which are generated by the parser)
 */

#ifndef PHC_REMOVE_CONCAT_NULL
#define PHC_REMOVE_CONCAT_NULL

#include "Tree_transform.h"

class Remove_concat_null : public Tree_transform
{
public:
	AST_expr* post_bin_op(AST_bin_op* in)
   {
		Token_string* empty = new Token_string(new String(""), new String(""));

		// Replace with right operand if left operand is the empty string 
		if(in->match(new AST_bin_op(empty, WILDCARD, ".")))
			return in->right;

		// Replace with left operand if right operand is the empty string 
		if(in->match(new AST_bin_op(WILDCARD, empty, ".")))
			return in->left;
		
		return in;
   }
};

#endif // PHC_REMOVE_CONCAT_NULL
