/* 
 * phc -- the open source PHP compiler 
 * See license/README.license for licensing information
 *
 * Checks for a return statement, and sets 'found' if one is found
 * 
 */

#ifndef PHC_RETURN_CHECK
#define PHC_RETURN_CHECK

class Return_check : public Tree_visitor
{
public:
	bool found;
	int line_number;

	Return_check()
	{
		found = false;
	}

	void pre_return(AST_return* in)
	{	
		if (not found)
		{
			found = true;
			line_number = in->get_line_number();
		}
	}

};

#endif


