/*
 * phc -- the open source PHP compiler
 * See license/README.license for licensing information
 *
 * Modify 'target' attribute on variables in %MAIN%::%run%()
 */

#ifndef PHC_VARIABLE_TARGETS
#define PHC_VARIABLE_TARGETS

#include "Tree_visitor.h"

class Variable_targets : public Tree_visitor
{
private:
	bool in_run;
	
public:
	Variable_targets() : in_run(false) {}
	virtual ~Variable_targets() {}

	void pre_method(AST_method* in)
	{
		in_run = *in->signature->method_name->value == "%run%";
	}

	void pre_variable(AST_variable* in)
	{
		if(in_run && !in->target)
		{
			in->target = new Token_class_name(new String("%MAIN%"));
		}
	}
};

#endif // PHC_VARIABLE_TARGETS
