/*
 * phc -- the open source PHP compiler
 * See license/README.license for licensing information
 *
 * Traversal to collect all pointers in an AST.
 */

#ifndef PHC_COLLECT_ALL_POINTERS
#define PHC_COLLECT_ALL_POINTERS

#include <algorithm>
#include <set>
#include "Tree_visitor.h"

class Collect_all_pointers : virtual public Tree_visitor 
{
public:
	list<AST_node*> all_pointers;
	set<AST_node*> unique_pointers;

public:
	void pre_node(AST_node* in)
	{
		all_pointers.push_back(in);
		unique_pointers.insert(in);
	}
};

#endif
