/*
 * phc -- the open source PHP compiler
 * See license/README.license for licensing information
 *
 * This transform tests the same number of pre_node and post_node calls are
 * done on an unmodified tree.
 */

#ifndef PHC_TEST_PRE_VS_POST_COUNT
#define PHC_TEST_PRE_VS_POST_COUNT

#include "Tree_transform.h"

class Test_pre_vs_post_count : public Tree_visitor
{
private:
	int count;

public:
	void pre_php_script(AST_php_script* in)
	{
		count = 0;
	}

	void post_php_script(AST_php_script* in)
	{
		if (count == 0)
		{
			printf("Success\n");
		}
		else 
		{
			printf("Failure\n");
			printf("Count is %d\n", count);
		}
	}

	void pre_node(AST_node* in)
	{
		count++;
	}

	void post_node(AST_node* out)
	{
		count--;
	}
};

#endif // PHC_TEST_PRE_VS_POST_COUNT
